#!/usr/bin/perl -w

use strict;                     # Pragma
#require 5.005_63;               # Versao de Perl necessria (>=5.005_50 ??)

my $linha;



while ($linha = <>) {
        print pintar(compactar_linha($linha));
}


sub pintar {
        my $tail = shift or die "Preciso de um parametro";
		$_ = $tail;
		s/^(.*)\/(.*?):/$2:/;
		s/`(.*?)'/[01;34m$1[0m/g;
		s/^(.*?):/sprintf("[01;31m%10s[0m:",$1)/e;
		s/:(\d+):/sprintf(":[02;32m%3s[0m:",$1)/e;
		return $_;
}

sub compactar_linha {
        my $tail = shift or die "Preciso de um parametro";
        my $head;
        my @output = ();
        my $re;
        $re = qr{
                <
                        (?: 
                                (?>[^<>]+)
                                |
                                (?p{$re})
                        )*
                >
        }x;

        while ($tail =~ $re) { 
        #  if ($tail =~ $re) { 
                $head =  $`;
                $tail = $';
                # print "### $head ### $& ### $tail ###\n";
                push @output, $head;
        }
        push @output, $tail;

        return join "<...>", @output;
}


__END__
#
# linhas de teste
# processadas a partir do filehandle DATA
#
linha1<def<>,ghi<>>glup<outra treta>;
linha2<def<>,ghi<>>glup<ainda<outra>treta>
linha3<def<>,ghi<>>glup<ainda<outra>treta>mais<uns<parenteses>>bla bla
#
# fim
#
